<template>
  <v-select
    v-model="field"
    :label="$t('generic.concept.type')"
    auto-select-first
    validate-on-blur
    item-title="title"
    item-value="value"
    :disabled="label === null"
    :items="parsedTypes"
    @input="onInput"
  >
    <template #item="{ item, on, attrs }">
      <v-list-item dense v-bind="attrs" v-on="on">
        <div :class="`type-background type-${makeCss(item.value)}`" />
        <v-list-item-title>
          {{ item.title }}
        </v-list-item-title>
      </v-list-item>
    </template>
    <template #append>
      <div :class="`type-icon type-${makeCss(field)}`" />
    </template>
    <template #selection="{ item }">
      <div class="type-input">
        {{ item.title }}
      </div>
    </template>
  </v-select>
</template>

<script lang="ts">
import {
  Component, Prop, Vue, Watch,
} from 'vue-property-decorator';
import { makeCssIdentifier } from '@/logic/CSSGenerator';
import type { Label } from '@/data';
import type AnalysisActions from '@/logic/AnalysisActions';

@Component
export default class TypeField extends Vue {
  /** @override */
  key = 'type' as const;

  @Prop({ required: true })
  types!: string[];

  @Prop({ required: true })
  label!: Label | null;

  @Prop({ required: true })
  actions!: AnalysisActions;

  field = '';

  parsedTypes: Array<{ title: string, value: string }> = [];

  mounted() {
    this.setParsedTypes();
  }

  setParsedTypes() {
    this.parsedTypes = [...this.types.map((t) => ({
      title: this.$t(`types.${t}`) === `types.${t}`
        ? t : this.$t(`types.${t}`).toString(),
      value: t,
    }))];
  }

  makeCss = makeCssIdentifier;

  onInput(newFieldValue: string) {
    if (!this.label) return;
    this.actions.updateLabel(this.label.id, this.key, newFieldValue);
  }

  protected resetField() {
    // Initialize the field
    if (this.label === null) {
      this.label = null;
      this.field = '';
    } else {
      this.field = this.label[this.key];
    }
  }

  @Watch('label')
  onLabelChange() {
    this.resetField();
    this.setParsedTypes();
  }
}
</script>
<style scoped lang="scss">
.type {
  &-background {
    opacity: 0.2;
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background-color: var(--label-color, white);
  }

  &-icon {
    opacity: 0.4;
    width: 1em;
    height: 1em;
    border-radius: 0.5em;
    border: 1px solid #000;
    background-color: var(--label-color, white);
  }

  &-input {
    position: absolute;
  }
}
</style>
